## mingw-w64-paraview-6.0.0-1.src.tar.zst

=== Adaptors/Cam/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause

set(headers
  fv_create_data.h
  se_create_data.h
)

set(sources
  fv_create_data.cxx
  se_create_data.cxx
)

set(template_classes
  Grid
)

vtk_module_add_module(ParaView::AdaptorsCam
  HEADERS          ${headers}
  SOURCES          ${sources}
  TEMPLATE_CLASSES ${template_classes}
)
vtk_module_client_server_exclude()

=== Clients/CommandLineExecutables/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause

# TODO: Restore Cray ATP support via a new module.
# TODO: Support static plugins.

# Set up rpaths
set(CMAKE_BUILD_RPATH_USE_ORIGIN 1)
if (UNIX AND NOT APPLE)
  file(RELATIVE_PATH _paraview_client_relpath
    "/prefix/${CMAKE_INSTALL_BINDIR}"
    "/prefix/${CMAKE_INSTALL_LIBDIR}")
  set(_paraview_client_origin_rpath
    "$ORIGIN/${_paraview_client_relpath}")

  list(APPEND CMAKE_INSTALL_RPATH
    "${_paraview_client_origin_rpath}")
endif()

# A plugin configuration file is required if either the GUI
# application is not built (the configuration file is provided
# there if so) or we're on macOS where the configuration file is
# then stored under the bundle for the application. Instead,
# provide our own configuration file instead.
if (APPLE OR NOT PARAVIEW_USE_QT)
  paraview_plugin_write_conf(
    NAME "paraview"
    PLUGINS_TARGETS ParaView::paraview_plugins
    BUILD_DESTINATION "${CMAKE_INSTALL_BINDIR}"
    INSTALL_DESTINATION "${CMAKE_INSTALL_BINDIR}"
    COMPONENT "runtime")
endif ()

include("${CMAKE_CURRENT_SOURCE_DIR}/ParaViewCommandLineExecutables.cmake")

set(paraview_tools)
foreach (exe IN ITEMS pvserver pvdataserver pvrenderserver)
  paraview_add_executable("${exe}" "${exe}.cxx")
  list(APPEND paraview_tools
    "${exe}")
endforeach ()

if (PARAVIEW_USE_PYTHON)
  foreach (exe IN ITEMS pvbatch pvpython)
    paraview_add_executable("${exe}" "${exe}.cxx")
    list(APPEND paraview_tools
      "${exe}")
  endforeach ()
endif ()

if (paraview_will_be_built)
  list(APPEND paraview_tools
    paraview)
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/paraview-config.in"
  "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/paraview-config"
  @ONLY)
install(
  PROGRAMS    "${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/paraview-config"
  DESTINATION "${CMAKE_INSTALL_BINDIR}"
  COMPONENT   development)

if (PARAVIEW_INSTALL_DEVELOPMENT_FILES)
  export(
    EXPORT      ParaViewTools
    NAMESPACE   ParaView::
    FILE        "${CMAKE_BINARY_DIR}/${paraview_cmake_destination}/ParaViewTools-targets.cmake")
  install(
    EXPORT      ParaViewTools
    NAMESPACE   ParaView::
    FILE        "ParaViewTools-targets.cmake"
    DESTINATION "${paraview_cmake_destination}"
    COMPONENT   "development")
endif ()

# obsolete in ParaView 5.9
vtk_obsolete_setting(PARAVIEW_BUILD_MESA_LAUNCHER)

=== Clients/ParaView/CMakeLists.txt ===
cmake_dependent_option(PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION
  "Build the ParaView help menu documentation for ParaView and its plugins" ON
  "PARAVIEW_USE_QT" ON)
mark_as_advanced(PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION)

set(xmls
  "${CMAKE_CURRENT_SOURCE_DIR}/ParaViewFilters.xml"
  "${CMAKE_CURRENT_SOURCE_DIR}/ParaViewSources.xml")

if (PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION)
  #------------------------------------------------------------------------------
  # Build Online-Help (aka Embedded Help) for the ParaView application.
  # This is done after the above piece of code that sets the application_gui_xmls
  # variable. Documentation/CMakeLists.txt depends on it.
  add_subdirectory(Documentation)
endif ()

if (DEFINED PARAVIEW_VERSION_NICKNAME)
  set(paraview_version "${PARAVIEW_VERSION_NICKNAME}")
else ()
  set(paraview_version "${PARAVIEW_VERSION_FULL}")
endif ()
set(paraview_title "ParaView ${paraview_version}")
if (PARAVIEW_BRANCH)
  set(paraview_title "ParaView ${paraview_version} (${PARAVIEW_BRANCH})")
endif ()

set(CMAKE_AUTOMOC 1)
set(CMAKE_AUTOUIC 1)

set(sources
  ParaViewMainWindow.cxx
  ParaViewMainWindow.h
  ParaViewMainWindow.ui)

find_package("Qt${PARAVIEW_QT_MAJOR_VERSION}" REQUIRED QUIET COMPONENTS Core Widgets)

if (APPLE)
  # Enable high resolution when using Qt5
  # This configuring of MacOSXBundleInfo may no longer be needed, but I am
  # leaving it in since in future we could build the supported extensions list
  # more exhaustively here.
  set(high_resolution_capable "true")
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/MacOSXBundleInfo.plist.in.in"
    "${CMAKE_CURRENT_BINARY_DIR}/MacOSXBundleInfo.plist.in"
    @ONLY)
  unset(high_resolution_capable)
endif ()

set(default_style)
if (WIN32)
  set(default_style "fusion")
endif ()

set(style_args)
if (default_style)
  list(APPEND style_args
    DEFAULT_STYLE "${default_style}")
endif ()

set(_paraview_client_add_translation_args)
if (PARAVIEW_BUILD_TRANSLATIONS)
  list(APPEND _paraview_client_add_translation_args
    TRANSLATIONS_DIRECTORY "${PARAVIEW_TRANSLATIONS_DIRECTORY}"
    TRANSLATION_TARGET "ParaViewClient.ts"
    TRANSLATE_XML "ON")
endif ()
paraview_client_add(
  NAME              paraview
  NAMESPACE         "ParaView"
  EXPORT            "ParaViewClient"
  APPLICATION_NAME  "ParaView"
  TITLE             "${paraview_title}"
  ORGANIZATION      "ParaView"
  VERSION           "${PARAVIEW_VERSION_MAJOR}.${PARAVIEW_VERSION_MINOR}.${PARAVIEW_VERSION_PATCH}"
  ${style_args}
  MAIN_WINDOW_CLASS "ParaViewMainWindow"
  BUNDLE_ICON       "${CMAKE_CURRENT_SOURCE_DIR}/pvIcon.icns"
  BUNDLE_PLIST      "${CMAKE_CURRENT_BINARY_DIR}/MacOSXBundleInfo.plist.in"
  APPLICATION_ICON  "${CMAKE_CURRENT_SOURCE_DIR}/pvIcon.ico"
  SOURCES           ${sources}
  PLUGINS_TARGETS   ParaView::paraview_plugins
  APPLICATION_XMLS  ${xmls}
  ${_paraview_client_add_translation_args})

if (PARAVIEW_BUILD_TRANSLATIONS AND TARGET "localization")
  add_dependencies(localization "ParaViewClient.ts")
endif()

find_package("Qt${PARAVIEW_QT_MAJOR_VERSION}" REQUIRED QUIET COMPONENTS Widgets)

target_link_libraries(paraview
  PRIVATE
    ParaView::RemotingSettings
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Core"
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Widgets")

target_compile_definitions(paraview
  PRIVATE
    "PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION=$<BOOL:${PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION}>")
if (PARAVIEW_ENABLE_EMBEDDED_DOCUMENTATION)
  target_link_libraries(paraview
    PRIVATE
      vtkParaViewDocumentation)
endif ()

if(PARAVIEW_QT_MAJOR_VERSION GREATER "5")
  find_package("Qt${PARAVIEW_QT_MAJOR_VERSION}" REQUIRED COMPONENTS Core5Compat)
  target_link_libraries(paraview
    PRIVATE
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::Core5Compat")
endif()

target_compile_definitions(paraview
  PRIVATE
    "PARAVIEW_USE_PYTHON=$<BOOL:${PARAVIEW_USE_PYTHON}>"
    "PARAVIEW_USE_EXTERNAL_VTK=$<BOOL:${PARAVIEW_USE_EXTERNAL_VTK}>")
if (PARAVIEW_USE_PYTHON)
  target_link_libraries(paraview
    PRIVATE
      ParaView::pvpythonmodules
      ParaView::pvincubatorpythonmodules
      ParaView::pqPython
      ParaView::PythonInitializer
      ParaView::PythonInterpreterPath)
endif ()

target_compile_definitions(paraview
  PRIVATE
    "PARAVIEW_USE_MATERIALEDITOR=$<BOOL:${paraview_use_materialeditor}>")

if (PARAVIEW_INSTALL_DEVELOPMENT_FILES)
  export(
    EXPORT    ParaViewClient
    NAMESPACE ParaView::
    FILE      "${CMAKE_BINARY_DIR}/${paraview_cmake_destination}/ParaViewClient-targets.cmake")
  install(
    EXPORT      ParaViewClient
    NAMESPACE   ParaView::
    FILE        ParaViewClient-targets.cmake
    DESTINATION "${paraview_cmake_destination}"
    COMPONENT   "development")
endif ()

if (BUILD_TESTING)
  add_subdirectory(Testing)
endif ()

if (UNIX AND NOT APPLE)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/org.paraview.ParaView.desktop.in"
    "${CMAKE_CURRENT_BINARY_DIR}/org.paraview.ParaView.desktop"
    @ONLY)
  install(
    FILES       "${CMAKE_CURRENT_BINARY_DIR}/org.paraview.ParaView.desktop"
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/applications"
    COMPONENT   runtime)
  foreach (iconsize IN ITEMS 22x22 32x32 96x96)
    install(
      FILES       "pvIcon-${iconsize}.png"
      DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/icons/hicolor/${iconsize}/apps"
      RENAME      paraview.png
      COMPONENT   runtime)
  endforeach ()
  install(
    FILES       org.paraview.ParaView.appdata.xml
    DESTINATION "${CMAKE_INSTALL_DATAROOTDIR}/metainfo"
    COMPONENT   runtime)
endif ()

set(paraview_xml_destination
  "${CMAKE_INSTALL_DATAROOTDIR}/paraview${paraview_version_suffix}/xmls")
install(
  FILES       ${xmls}
  DESTINATION "${paraview_xml_destination}"
  COMPONENT   "development")

set_property(GLOBAL APPEND
  PROPERTY
    paraview_client_xml_files "${xmls}")
set_property(GLOBAL
  PROPERTY
    paraview_client_xml_destination "${paraview_xml_destination}")

=== Incubator/CAVEInteractionStyles/CMakeLists.txt ===
set(classes
  vtkSMVRControlSliceOrientationStyleProxy
  vtkSMVRControlSlicePositionStyleProxy
  vtkSMVRGrabPointStyleProxy
  vtkSMVRGrabTransformStyleProxy
  vtkSMVRGrabWorldStyleProxy
  vtkSMVRInteractorStyleProxy
  vtkSMVRMovePointStyleProxy
  vtkSMVRPythonInteractorStyleProxy
  vtkSMVRResetTransformStyleProxy
  vtkSMVRSkeletonStyleProxy
  vtkSMVRStylusStyleProxy
  vtkSMVRTrackStyleProxy
  vtkSMVRVirtualHandStyleProxy
  vtkVRQueue)

vtk_module_add_module(ParaViewIncubator::CAVEInteractionStyles
  CLASSES ${classes})

=== Plugins/CAVEInteraction/CMakeLists.txt ===
find_package("Qt${PARAVIEW_QT_MAJOR_VERSION}" QUIET REQUIRED COMPONENTS Network)

list(INSERT CMAKE_MODULE_PATH 0
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

option(PARAVIEW_PLUGIN_CAVEInteraction_USE_VRPN "Build CAVEInteraction plugin with VRPN support" OFF)
mark_as_advanced(PARAVIEW_PLUGIN_CAVEInteraction_USE_VRPN)
option(PARAVIEW_PLUGIN_CAVEInteraction_USE_VRUI "Build CAVEInteraction plugin with VRUI support" OFF)
mark_as_advanced(PARAVIEW_PLUGIN_CAVEInteraction_USE_VRUI)

# TODO: Should something be done with the files in samples/?

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkPVVRConfig.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkPVVRConfig.h"
  @ONLY)

set(sources
  pqVRAddConnectionDialog.cxx
  pqVRAddConnectionDialog.h
  pqVRAddStyleDialog.cxx
  pqVRAddStyleDialog.h
  pqVRCollaborationWidget.cxx
  pqVRCollaborationWidget.h
  pqVRConnectionManager.cxx
  pqVRConnectionManager.h
  pqVRDockPanel.cxx
  pqVRDockPanel.h
  pqVRQueueHandler.cxx
  pqVRQueueHandler.h
  pqVRStarter.cxx
  pqVRStarter.h
  vtkVRInteractorStyleFactory.cxx
  vtkVRInteractorStyleFactory.h
  "${CMAKE_CURRENT_BINARY_DIR}/vtkPVVRConfig.h")

set_property(
  SOURCE
  pqVRDockPanel.cxx
  pqVRCollaborationWidget.cxx
  APPEND PROPERTY
    COMPILE_DEFINITIONS "CAVEINTERACTION_HAS_COLLABORATION=$<BOOL:${VTK_ENABLE_VR_COLLABORATION}>")

if (PARAVIEW_PLUGIN_CAVEInteraction_USE_VRPN)
  find_package(VRPN REQUIRED)
  list(APPEND sources
    pqVRPNConnection.cxx
    pqVRPNConnection.h
    pqVRPNEventListener.cxx
    pqVRPNEventListener.h
    vtkVRPNCallBackHandlers.cxx
    vtkVRPNCallBackHandlers.h)
endif ()

if (PARAVIEW_PLUGIN_CAVEInteraction_USE_VRUI)
  list(APPEND sources
    pqVRUIConnection.cxx
    pqVRUIConnection.h
    vtkVRUIPipe.cxx
    vtkVRUIPipe.h
    vtkVRUIServerState.cxx
    vtkVRUIServerState.h
    vtkVRUITrackerState.cxx
    vtkVRUITrackerState.h)
endif ()

set(ui_files
  pqVRAddConnectionDialog.ui
  pqVRAddStyleDialog.ui
  pqVRCollaborationWidget.ui
  pqVRDockPanel.ui)

if (VTK_ENABLE_VR_COLLABORATION)
  list(APPEND ui_files
    pqVRAvatarEvents.ui)
  list(APPEND sources
    pqVRAvatarEvents.h
    pqVRAvatarEvents.cxx
    vtkSMVRCollaborationStyleProxy.h
    vtkSMVRCollaborationStyleProxy.cxx)
endif ()

set(interfaces)
paraview_plugin_add_auto_start(
  CLASS_NAME "pqVRStarter"
  STARTUP onStartup
  SHUTDOWN onShutdown
  INTERFACES autostart_interface
  SOURCES autostart_sources)
list(APPEND interfaces
  ${autostart_interface})
list(APPEND sources
  ${autostart_sources})

paraview_plugin_add_dock_window(
  CLASS_NAME pqVRDockPanel
  DOCK_AREA Left
  INTERFACES dock_interfaces
  SOURCES dock_sources)
list(APPEND interfaces
  ${dock_interfaces})
list(APPEND sources
  ${dock_sources})

set(xml_files
  CAVEInteraction_SM.xml)
if (PARAVIEW_USE_PYTHON)
  list(APPEND xml_files
    CAVEInteraction_SM_Python.xml)
endif ()

paraview_add_plugin(CAVEInteraction
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  UI_INTERFACES ${interfaces}
  UI_FILES ${ui_files}
  SOURCES ${sources}
  SERVER_MANAGER_XML ${xml_files}
  MODULES ParaViewIncubator::CAVEInteractionStyles
  XML_DOCUMENTATION OFF)

target_include_directories(CAVEInteraction
  PRIVATE
    "${CMAKE_CURRENT_BINARY_DIR}")

target_link_libraries(CAVEInteraction
  PRIVATE
    ParaView::RemotingCore
    ParaView::RemotingServerManager
    ParaView::RemotingViews
    ParaView::pqApplicationComponents
    VTK::CommonCore
    VTK::CommonMath
    VTK::CommonTransforms
    VTK::RenderingCore
    VTK::RenderingOpenGL2
    VTK::RenderingVR
    "Qt${PARAVIEW_QT_MAJOR_VERSION}::Network")
target_compile_definitions(CAVEInteraction PRIVATE QT_NO_KEYWORDS)

if (PARAVIEW_PLUGIN_CAVEInteraction_USE_VRPN)
  target_link_libraries(CAVEInteraction
    PRIVATE
      VRPN::VRPN)
endif ()

=== Plugins/DSP/CMakeLists.txt ===
set(sources)
set(interfaces)
set(uifiles)

cmake_dependent_option(PARAVIEW_PLUGIN_dsp_enable_audio_player "Enable building the Audio Player Dock. Requires Qt5 Multimedia." OFF
  "PARAVIEW_QT_MAJOR_VERSION EQUAL 5" OFF)
mark_as_advanced(PARAVIEW_PLUGIN_dsp_enable_audio_player)

if (PARAVIEW_USE_QT AND PARAVIEW_PLUGIN_dsp_enable_audio_player)
  find_package("Qt${PARAVIEW_QT_MAJOR_VERSION}" REQUIRED Widgets OPTIONAL_COMPONENTS Multimedia)

  if (NOT TARGET "Qt${PARAVIEW_QT_MAJOR_VERSION}::Multimedia")
    message(FATAL_ERROR
      "Component 'Qt5::Multimedia' required for the DSP plugin not found. Use "
      "PARAVIEW_PLUGIN_dsp_enable_audio_player to disable the audio player if necessary, or install 'Qt5::Multimedia'")
  endif ()

  list(APPEND sources
    pqAudioPlayer.cxx
    pqAudioPlayer.h)

  paraview_plugin_add_dock_window(
    CLASS_NAME pqAudioPlayer
    DOCK_AREA Right
    INTERFACES dock_interfaces
    SOURCES dock_sources)

  list(APPEND interfaces
    ${dock_interfaces})
  list(APPEND sources
    ${dock_sources})
  list(APPEND uifiles pqAudioPlayer.ui)
endif ()

paraview_add_plugin(DigitalSignalProcessing
  VERSION "1.0"
  UI_FILES ${uifiles}
  UI_INTERFACES ${interfaces}
  SOURCES ${sources}
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  MODULES
    DigitalSignalProcessing::DSPDataModel
    DigitalSignalProcessing::DSPFiltersPlugin
  MODULE_FILES
    "${CMAKE_CURRENT_SOURCE_DIR}/DataModel/vtk.module"
    "${CMAKE_CURRENT_SOURCE_DIR}/Filters/vtk.module")

# XXX(cmake-3.13)
if (COMMAND target_link_options)
  # XXX(cmake-3.29): Suppress warnings with Xcode 15+ linkers; resolved with
  # CMake 3.29.
  if (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" AND
      CMAKE_CXX_COMPILER_VERSION VERSION_GREATER "15")
    target_link_options(DigitalSignalProcessing
      PRIVATE
        "$<$<PLATFORM_ID:Darwin>:LINKER:-no_warn_duplicate_libraries>")
  endif ()
endif ()

if (PARAVIEW_USE_QT AND PARAVIEW_PLUGIN_dsp_enable_audio_player)
  target_link_libraries(DigitalSignalProcessing
    PRIVATE
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::Widgets"
      "Qt${PARAVIEW_QT_MAJOR_VERSION}::Multimedia")

  target_compile_definitions(DigitalSignalProcessing PRIVATE QT_NO_KEYWORDS)
endif()

if (BUILD_TESTING AND BUILD_SHARED_LIBS)
  add_subdirectory(Testing)
endif()

=== Plugins/LegacyExodusWriter/CMakeLists.txt ===
paraview_add_plugin(LegacyExodusWriter
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  SERVER_MANAGER_XML LegacyExodusWriter.xml)

=== Plugins/XArrayCFReader/CMakeLists.txt ===
if (PARAVIEW_USE_PYTHON)
  paraview_add_plugin(
    XArrayCFReader
    REQUIRED_ON_SERVER
    VERSION "1.0"
    EULA "Help.txt"
    PYTHON_MODULES XArrayCFReader.py
  )
endif()

=== Plugins/ZSpace/CMakeLists.txt ===
list(INSERT CMAKE_MODULE_PATH 0
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
set(sources)
set(interfaces)

if (PARAVIEW_USE_QT)
  list(APPEND sources
    pqZSpaceManager.cxx
    pqZSpaceManager.h)

  paraview_plugin_add_auto_start(
    CLASS_NAME "pqZSpaceManager"
    STARTUP onStartup
    SHUTDOWN onShutdown
    INTERFACES autostart_interface
    SOURCES autostart_sources)
  list(APPEND interfaces
    ${autostart_interface})
  list(APPEND sources
    ${autostart_sources})
endif ()

paraview_add_plugin(zSpace
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  UI_INTERFACES ${interfaces}
  SOURCES ${sources}
  MODULES zSpace::vtkZSpaceView
  MODULE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/zSpace/vtk.module"
  XML_DOCUMENTATION OFF)

if (PARAVIEW_USE_QT)
  target_link_libraries(zSpace
    PRIVATE
      ParaView::RemotingViews)
  target_compile_definitions(zSpace PRIVATE QT_NO_KEYWORDS)
endif ()

=== Remoting/Import/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkSIImporterProxy
  vtkSMImporterProxy
  vtkSMImporterFactory)

vtk_module_add_module(ParaView::RemotingImport
  CLASSES ${classes})

=== ThirdParty/CosmoHaloFinder/CMakeLists.txt ===
vtk_module_third_party_internal(
  LICENSE_FILES 
    "vtkcosmohalofinder/LICENSE"
  SPDX_LICENSE_IDENTIFIER
    "BSD-3-Clause"
  SPDX_COPYRIGHT_TEXT
    "Copyright (c) 2007, Los Alamos National Security, LLC"
  SPDX_DOWNLOAD_LOCATION
    "git+https://gitlab.kitware.com/paraview/paraview/-/tree/master/ThirdParty/CosmoHaloFinder/vtkcosmohalofinder"
  VERSION       
    "master"
  STANDARD_INCLUDE_DIRS)

=== Utilities/Sphinx/CMakeLists.txt ===
# Build Sphinx documentation for Python modules.
if (NOT PARAVIEW_USE_PYTHON)
  return()
endif()

include(ParaViewFindPythonModules)
find_python_module("sphinx" sphinx_found)
if (NOT sphinx_found)
  message(WARNING
    "Please install Sphinx to generate documentation for Python modules.")
  return ()
endif ()

# Copy files referenced from docstrings.
configure_file(
  "${ParaView_SOURCE_DIR}/Examples/Plugins/PythonAlgorithm/Plugin/PythonAlgorithmExamples.py"
  "${CMAKE_CURRENT_BINARY_DIR}/PythonAlgorithmExamples.py"
  @ONLY)

set(sphinx_config_files
  config/_themes/sphinx_rtd_theme/static/css/badge_only.css
  config/_themes/sphinx_rtd_theme/static/css/fonts/Roboto-Slab-Bold.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/Roboto-Slab-Bold.woff2
  config/_themes/sphinx_rtd_theme/static/css/fonts/Roboto-Slab-Regular.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/Roboto-Slab-Regular.woff2
  config/_themes/sphinx_rtd_theme/static/css/fonts/fontawesome-webfont.eot
  config/_themes/sphinx_rtd_theme/static/css/fonts/fontawesome-webfont.svg
  config/_themes/sphinx_rtd_theme/static/css/fonts/fontawesome-webfont.tff
  config/_themes/sphinx_rtd_theme/static/css/fonts/fontawesome-webfont.ttf
  config/_themes/sphinx_rtd_theme/static/css/fonts/fontawesome-webfont.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/fontawesome-webfont.woff2
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-bold-italic.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-bold-italic.woff2
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-bold.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-bold.woff2
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-normal-italic.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-normal-italic.woff2
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-normal.woff
  config/_themes/sphinx_rtd_theme/static/css/fonts/lato-normal.woff2
  config/_themes/sphinx_rtd_theme/static/css/theme.css
  config/_themes/sphinx_rtd_theme/static/js/badge_only.js
  config/_themes/sphinx_rtd_theme/static/js/theme.js
  config/_themes/sphinx_rtd_theme/__init__.py
  config/_themes/sphinx_rtd_theme/breadcrumbs.html
  config/_themes/sphinx_rtd_theme/footer.html
  config/_themes/sphinx_rtd_theme/locale
  config/_themes/sphinx_rtd_theme/locale/de
  config/_themes/sphinx_rtd_theme/locale/de/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/de/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/en/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/en/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/es/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/es/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/et/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/et/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/fa_IR/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/fa_IR/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/fr/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/fr/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/it/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/it/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/lt/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/lt/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/nl/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/nl/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/pl/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/pl/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/pt/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/pt/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/pt_BR/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/pt_BR/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/ru/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/ru/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/sphinx.pot
  config/_themes/sphinx_rtd_theme/locale/sv/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/sv/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/tr/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/tr/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/locale/zh_CN/LC_MESSAGES/sphinx.mo
  config/_themes/sphinx_rtd_theme/locale/zh_CN/LC_MESSAGES/sphinx.po
  config/_themes/sphinx_rtd_theme/search.html
  config/_themes/sphinx_rtd_theme/searchbox.html
  config/_themes/sphinx_rtd_theme/theme.conf
  config/_themes/sphinx_rtd_theme/versions.html
  config/_themes/sphinx_rtd_theme/layout.html
  config/quick-start.rst
  config/api-changes.rst
  config/conf.py.in
  config/index.rst)

set(_sphinx_depends_args)
if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.27")
  list(APPEND _sphinx_depends_args
    DEPENDS_EXPLICIT_ONLY)
endif ()

set(paraview_paths
  "['${ParaView_BINARY_DIR}/${PARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX}',
    '${CMAKE_RUNTIME_OUTPUT_DIRECTORY}',
    '${CMAKE_LIBRARY_OUTPUT_DIRECTORY}']")

set(sphinx_copied_files)
foreach (sphinx_config_file IN LISTS sphinx_config_files)
  set(output_config_file
    "${CMAKE_CURRENT_BINARY_DIR}/${sphinx_config_file}")
  if (sphinx_config_file MATCHES "\\.in$")
    string(REPLACE ".in" "" output_config_file "${output_config_file}")
    configure_file(
      "${sphinx_config_file}"
      "${output_config_file}"
      @ONLY)
  else ()
    add_custom_command(
      OUTPUT  "${output_config_file}"
      DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${sphinx_config_file}"
      COMMAND "${CMAKE_COMMAND}" -E copy_if_different
              "${CMAKE_CURRENT_SOURCE_DIR}/${sphinx_config_file}"
              "${output_config_file}"
      COMMENT "Copying ${sphinx_config_file} to the binary directory"
      ${_sphinx_depends_args})
  endif ()
  list(APPEND sphinx_copied_files
    "${output_config_file}")
endforeach ()

add_custom_target(paraview_copy_sphinx_config
  DEPENDS
    ${sphinx_copied_files})

set(nompi_flags)
if (PARAVIEW_USE_MPI)
  set(nompi_flags "--no-mpi")
endif ()

set(venv_flags)
if (DEFINED ENV{VIRTUAL_ENV})
  list(APPEND venv_flags
    --venv "$ENV{VIRTUAL_ENV}")
endif ()

add_custom_target(ParaViewPythonDoc
  DEPENDS paraview_copy_sphinx_config
          paraview_all_python_modules
  COMMAND "$<TARGET_FILE:pvpython>"
          ${venv_flags}
          ${nompi_flags}
          "${CMAKE_CURRENT_SOURCE_DIR}/sphinx_apidoc.py"
          -o "${CMAKE_CURRENT_BINARY_DIR}/config"
          "${ParaView_BINARY_DIR}/${PARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX}/paraview"
          # CI utilities end up living here.
          ".gitlab"
          # CI venv
          "venv"
  COMMAND "$<TARGET_FILE:pvpython>"
          ${venv_flags}
          ${nompi_flags}
          -m sphinx
          -b html "${CMAKE_CURRENT_BINARY_DIR}/config"
          "${PARAVIEW_GENERATED_DOCUMENTATION_OUTPUT_DIRECTORY}/python"
  SOURCES sphinx_apidoc.py
          parse_pydoc_output.py
          ${sphinx_config_files}
  COMMENT "Generate Python HTML documentation"
  # ensures that the output is continuously generated
  # when using ninja; avoids builder from timing out
  USES_TERMINAL)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=paraview
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=6.0.0
pkgrel=1
pkgdesc="Parallel Data Analysis and Visualization Application based on VTK. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.paraview.org/'
msys2_repository_url="https://gitlab.kitware.com/paraview/paraview"
msys2_references=(
  'archlinux: paraview'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-cc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-cgns"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-tools"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         "${MINGW_PACKAGE_PREFIX}-vtk"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-libxslt"
             "${MINGW_PACKAGE_PREFIX}-proj"
             "${MINGW_PACKAGE_PREFIX}-qt6-svg"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json")
optdepends=("${MINGW_PACKAGE_PREFIX}-python-numpy"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib")
source=("https://www.paraview.org/files/v${pkgver%.*}/ParaView-v${pkgver}.tar.xz")
sha256sums=('0ee07ae6377e5e97766aebf858eb9758668a52df041f319e7c975037a63bf189')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/ParaView-v${pkgver}
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys; print(f'{sys.version_info.major}.{sys.version_info.minor}')")

  CXXFLAGS+=" -w -Wno-register" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DPARAVIEW_BUILD_SHARED_LIBS=ON \
      -DPARAVIEW_USE_PYTHON=ON \
      -DPARAVIEW_USE_QT=ON \
      -DPARAVIEW_USE_MPI=OFF \
      -DPARAVIEW_ENABLE_GDAL=ON \
      -DPARAVIEW_ENABLE_LAS=ON \
      -DPARAVIEW_ENABLE_OPENTURNS=ON \
      -DPARAVIEW_ENABLE_PDAL=ON \
      -DPARAVIEW_VERSIONED_INSTALL=OFF \
      -DPARAVIEW_BUILD_WITH_EXTERNAL=ON \
      -DPARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX="lib/python${_pyver}/site-packages/pv/" \
      -DPARAVIEW_USE_EXTERNAL_VTK=ON \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      ../ParaView-v${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  install -Dm644 "${srcdir}"/ParaView-v${pkgver}/Copyright.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}
